#!/usr/bin/env python2
import os
from os import system,chdir
dname = {'epsilon_normalized':2,'kddb':5,'news20.binary':0,'rcv1_test.binary':1,'url_combined':4,'webspam_wc_normalized_trigram.svm':3,'criteo':5,'kdd2012':6}
Cs = {0.001:0,1:1,1000.0:2}
solver = {'VL-BFGS':0,'TRON':1,'L-COMMDIR-GRAD':2,'L-COMMDIR-STEP':3,'L-COMMDIR-BFGS':4,'NEWTON':5}

#remove those method/data/loss parameters you are not interested in its result
methodlist = ['VL-BFGS','TRON','L-COMMDIR-BFGS','L-COMMDIR-STEP','L-COMMDIR-GRAD','NEWTON']
data = ['epsilon_normalized','kddb','news20.binary','rcv1_test.binary','url_combined','webspam_wc_normalized_trigram.svm']
loss_param = [0.001, 1, 1000.0]

cmd = " mkdir ./log ./model 2>/dev/null; mkdir figures/ 2> /dev/null;"
system(cmd)

machines = []
for line in open('./machinelist','r').readlines():
	machine = line.strip()
	machines.append(machine)
for i in machines:
	cmd = "ssh %s -x 'mkdir -p %s' >/dev/null 2>/dev/null"%(i, os.path.join(os.getcwd()))
	system(cmd)
	cmd = 'scp -r l-commdir %s:%s/ >/dev/null 2>/dev/null'%(i, os.path.join(os.getcwd()))
	system(cmd)
	cmd = "ssh %s -x 'cd %s; make clean all -C l-commdir' >/dev/null 2>/dev/null"%(i, os.path.join(os.getcwd()))
	system(cmd)

if (len(methodlist) == 0 or len(data) == 0 or len(loss_param) == 0):
	sys.exit(0)
	
tmp = []
for c in loss_param:
	for d in data:
		for method in methodlist:
			dp = '%s.C%s.%s'%(d,c, method)
			if not os.path.exists('log/%s.log'%dp):
				tmp.append((c,d,method))

for l in tmp:
	c,d,method = l
	dp = '%s.C%s.%s'%(d,c, method)
	traindata = 'data/'+ d
	model = 'model/%s.model'%(dp)
	cmd = ''
	m = 10
	if (method == 'mlbfgs'):
		m = 5
	cmd = 'mpirun -npernode 1 -hostfile ./machinelist l-commdir/train -s %s -e 1e-6 -c %s -m %d %s %s >> log/%s.log 2>/dev/null'%(solver[method], c, m, traindata, model, dp)
	system('echo \'%s\' > log/%s.log'%(cmd, dp))
	system(cmd)

ds = [0]*len(dname)
for i in data:
	ds[dname[i]] = 1

line1 = 'ds = [%d'%ds[0]
for i in ds[1:]:
	line1 += ',%d'%i
line1 += '];\n'

p = open("./tmp.m","w")
p.write(line1)
Clist = [0] * len(Cs)
for i in loss_param:
	Clist[Cs[i]] = 1
line2 = 'Cs = [%d'%Clist[0]
for i in Clist[1:]:
	line2 += ',%d'%i
line2 += '];\n'
p.write(line2)
line3 = "solvers = {'%s'"%methodlist[0]
for i in methodlist[1:]:
	line3 += ";'%s'"%i
line3 += '};\n'
p.write(line3)

p.close()
cmd = "cat ./compare.m >> ./tmp.m"
system(cmd)

cmd = "matlab -nodisplay -nodesktop -r \"tmp;exit\""
system(cmd)
